## GoaPasswordBased GoaPasswordBased — Generated C code for the org.gnome.OnlineAccounts.PasswordBased D-Bus interface |

## Functions

GDBusInterfaceInfo * | goa_password_based_interface_info ()
guint | goa_password_based_override_properties ()
void | goa_password_based_call_get_password ()
gboolean | goa_password_based_call_get_password_finish ()
gboolean | goa_password_based_call_get_password_sync ()
void | goa_password_based_complete_get_password ()
void | goa_password_based_proxy_new ()
GoaPasswordBased * | goa_password_based_proxy_new_finish ()
GoaPasswordBased * | goa_password_based_proxy_new_sync ()
void | goa_password_based_proxy_new_for_bus ()
GoaPasswordBased * | goa_password_based_proxy_new_for_bus_finish ()
GoaPasswordBased * | goa_password_based_proxy_new_for_bus_sync ()
GoaPasswordBased * | goa_password_based_skeleton_new ()

## Signals

gboolean | handle-get-password | Run Last

## Types and Values

| GoaPasswordBased
struct | GoaPasswordBasedIface
struct | GoaPasswordBasedProxy
struct | GoaPasswordBasedProxyClass
struct | GoaPasswordBasedSkeleton
struct | GoaPasswordBasedSkeletonClass

## Object Hierarchy

        GInterface
        ╰── GoaPasswordBased
        GObject
        ├── GDBusInterfaceSkeleton
        │   ╰── GoaPasswordBasedSkeleton
        ╰── GDBusProxy
            ╰── GoaPasswordBasedProxy

## Prerequisites

GoaPasswordBased requires GObject.

## Implemented Interfaces

GoaPasswordBasedProxy implements GDBusInterface, GInitable, GAsyncInitable and GoaPasswordBased.

GoaPasswordBasedSkeleton implements GDBusInterface and GoaPasswordBased.

## Known Implementations

GoaPasswordBased is implemented by GoaPasswordBasedProxy and GoaPasswordBasedSkeleton.

## Description

This section contains code for working with the org.gnome.OnlineAccounts.PasswordBased D-Bus interface in C.

## Functions

### goa_password_based_interface_info ()

    GDBusInterfaceInfo *
    goa_password_based_interface_info (void);

Gets a machine-readable description of the org.gnome.OnlineAccounts.PasswordBased D-Bus interface.

#### Returns

A GDBusInterfaceInfo. Do not free.

[transfer none]

Since: 3.6.0

### goa_password_based_override_properties ()

    guint
    goa_password_based_override_properties
                                   (GObjectClass *klass,
                                    guint property_id_begin);

Overrides all GObject properties in the GoaPasswordBased interface for a concrete class. The properties are overridden in the order they are defined.

#### Parameters

klass | The class structure for a GObject derived class. |
property_id_begin | The property id to assign to the first overridden property. |

#### Returns

The last property id.

Since: 3.6.0

### goa_password_based_call_get_password ()

    void
    goa_password_based_call_get_password (GoaPasswordBased *proxy,
                                          const gchar *arg_id,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Asynchronously invokes the `GetPassword()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `goa_password_based_call_get_password_finish()` to get the result of the operation.

See `goa_password_based_call_get_password_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A GoaPasswordBasedProxy. |
arg_id | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

Since: 3.6.0

### goa_password_based_call_get_password_finish ()

    gboolean
    goa_password_based_call_get_password_finish
                                   (GoaPasswordBased *proxy,
                                    gchar **out_password,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `goa_password_based_call_get_password()`.

#### Parameters

proxy | A GoaPasswordBasedProxy. |
out_password | Return location for return parameter or `NULL` to ignore. | [out][optional]
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `goa_password_based_call_get_password()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.6.0

### goa_password_based_call_get_password_sync ()

    gboolean
    goa_password_based_call_get_password_sync
                                   (GoaPasswordBased *proxy,
                                    const gchar *arg_id,
                                    gchar **out_password,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `GetPassword()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `goa_password_based_call_get_password()` for the asynchronous version of this method.

#### Parameters

proxy | A GoaPasswordBasedProxy. |
arg_id | Argument to pass with the method invocation. |
out_password | Return location for return parameter or `NULL` to ignore. | [out][optional]
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeded, `FALSE` if `error` is set.

[skip]

Since: 3.6.0

### goa_password_based_complete_get_password ()

    void
    goa_password_based_complete_get_password
                                   (GoaPasswordBased *object,
                                    GDBusMethodInvocation *invocation,
                                    const gchar *password);

Helper function used in service implementations to finish handling invocations of the `GetPassword()` D-Bus method. If you instead want to finish handling an invocation by returning an error, use `g_dbus_method_invocation_return_error()` or similar.

This method will free `invocation` , you cannot use it afterwards.

#### Parameters

object | A GoaPasswordBased. |
invocation | A GDBusMethodInvocation. | [transfer full]
password | Parameter to return. |

Since: 3.6.0

### goa_password_based_proxy_new ()

    void
    goa_password_based_proxy_new (GDBusConnection *connection,
                                  GDBusProxyFlags flags,
                                  const gchar *name,
                                  const gchar *object_path,
                                  GCancellable *cancellable,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

Asynchronously creates a proxy for the D-Bus interface org.gnome.OnlineAccounts.PasswordBased. See `g_dbus_proxy_new()` for more details.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `goa_password_based_proxy_new_finish()` to get the result of the operation.

See `goa_password_based_proxy_new_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 3.6.0

### goa_password_based_proxy_new_finish ()

    GoaPasswordBased *
    goa_password_based_proxy_new_finish (GAsyncResult *res,
                                         GError **error);

Finishes an operation started with `goa_password_based_proxy_new()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `goa_password_based_proxy_new()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaPasswordBasedProxy]

Since: 3.6.0

### goa_password_based_proxy_new_sync ()

    GoaPasswordBased *
    goa_password_based_proxy_new_sync (GDBusConnection *connection,
                                       GDBusProxyFlags flags,
                                       const gchar *name,
                                       const gchar *object_path,
                                       GCancellable *cancellable,
                                       GError **error);

Synchronously creates a proxy for the D-Bus interface org.gnome.OnlineAccounts.PasswordBased. See `g_dbus_proxy_new_sync()` for more details.

The calling thread is blocked until a reply is received.

See `goa_password_based_proxy_new()` for the asynchronous version of this constructor.

#### Parameters

connection | A GDBusConnection. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique) or `NULL` if `connection` is not a message bus connection. | [nullable]
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaPasswordBasedProxy]

Since: 3.6.0

### goa_password_based_proxy_new_for_bus ()

    void
    goa_password_based_proxy_new_for_bus (GBusType bus_type,
                                          GDBusProxyFlags flags,
                                          const gchar *name,
                                          const gchar *object_path,
                                          GCancellable *cancellable,
                                          GAsyncReadyCallback callback,
                                          gpointer user_data);

Like `goa_password_based_proxy_new()` but takes a GBusType instead of a GDBusConnection.

When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from. You can then call `goa_password_based_proxy_new_for_bus_finish()` to get the result of the operation.

See `goa_password_based_proxy_new_for_bus_sync()` for the synchronous, blocking version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied. |
user_data | User data to pass to `callback` . |

Since: 3.6.0

### goa_password_based_proxy_new_for_bus_finish ()

    GoaPasswordBased *
    goa_password_based_proxy_new_for_bus_finish
                                   (GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `goa_password_based_proxy_new_for_bus()`.

#### Parameters

res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `goa_password_based_proxy_new_for_bus()`. |
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaPasswordBasedProxy]

Since: 3.6.0

### goa_password_based_proxy_new_for_bus_sync ()

    GoaPasswordBased *
    goa_password_based_proxy_new_for_bus_sync
                                   (GBusType bus_type,
                                    GDBusProxyFlags flags,
                                    const gchar *name,
                                    const gchar *object_path,
                                    GCancellable *cancellable,
                                    GError **error);

Like `goa_password_based_proxy_new_sync()` but takes a GBusType instead of a GDBusConnection.

The calling thread is blocked until a reply is received.

See `goa_password_based_proxy_new_for_bus()` for the asynchronous version of this constructor.

#### Parameters

bus_type | A GBusType. |
flags | Flags from the GDBusProxyFlags enumeration. |
name | A bus name (well-known or unique). |
object_path | An object path. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL` |

#### Returns

The constructed proxy object or `NULL` if `error` is set.

[transfer full][type GoaPasswordBasedProxy]

Since: 3.6.0

### goa_password_based_skeleton_new ()

    GoaPasswordBased *
    goa_password_based_skeleton_new (void);

Creates a skeleton object for the D-Bus interface org.gnome.OnlineAccounts.PasswordBased.

#### Returns

The skeleton object.

[transfer full][type GoaPasswordBasedSkeleton]

Since: 3.6.0

## Types and Values

### GoaPasswordBased

    typedef struct _GoaPasswordBased GoaPasswordBased;

Abstract interface type for the D-Bus interface org.gnome.OnlineAccounts.PasswordBased.

Since: 3.6.0

### struct GoaPasswordBasedIface

    struct GoaPasswordBasedIface {
      GTypeInterface parent_iface;

      gboolean (*handle_get_password) (
        GoaPasswordBased *object,
        GDBusMethodInvocation *invocation,
        const gchar *arg_id);
    };

Virtual table for the D-Bus interface org.gnome.OnlineAccounts.PasswordBased.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_get_password` () | Handler for the “handle-get-password” signal. |

Since: 3.6.0

### struct GoaPasswordBasedProxy

    struct GoaPasswordBasedProxy;

The GoaPasswordBasedProxy structure contains only private data and should only be accessed using the provided API.

Since: 3.6.0

### struct GoaPasswordBasedProxyClass

    struct GoaPasswordBasedProxyClass {
      GDBusProxyClass parent_class;
    };

Class structure for GoaPasswordBasedProxy.

#### Members

Since: 3.6.0

### struct GoaPasswordBasedSkeleton

    struct GoaPasswordBasedSkeleton;

The GoaPasswordBasedSkeleton structure contains only private data and should only be accessed using the provided API.

Since: 3.6.0

### struct GoaPasswordBasedSkeletonClass

    struct GoaPasswordBasedSkeletonClass {
      GDBusInterfaceSkeletonClass parent_class;
    };

Class structure for GoaPasswordBasedSkeleton.

#### Members

Since: 3.6.0

## Signal Details

### The `“handle-get-password”` signal

    gboolean
    user_function (GoaPasswordBased      *object,
                   GDBusMethodInvocation *invocation,
                   gchar                 *arg_id,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `GetPassword()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `goa_password_based_complete_get_password()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A GoaPasswordBased. |
invocation | A GDBusMethodInvocation. |
arg_id | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

Since: 3.6.0